//-------------------------------------Concept.h--------------------------------
//
//    ChadNet by Chad Rempp
//    March 1 2002
//    Version 0.0.02
//
//	  Also Stolen from M Buckland
//
//    Concept Class
//    Represents a concept through an NN
//
//------------------------------------------------------------------------------

#include "concept.h"

// *****HACK***** I took this out because it was causing problems for the moment
//extern SimData_typ g_SimData;


//********************Methods for Concept class*********************************
//
//

//-----------------------default constructor------------------------------------
//

Concept::Concept(){
                   m_NumInputs          = 2; //g_SimData.NumInputs;
                   m_NumOutputs         = 2; //g_SimData.NumOutputs;
                   m_NumHiddenLayers    = 2; //g_SimData.NumHiddenLayers;
                   m_NumNeuronsPerLayer = 3; //g_SimData.NeuronsPerHLayer;

                   CreateNet();

}


//-----------------------overloded constructor----------------------------------
//
Concept::Concept( int NumInputs,
                  int NumOutputs,
                  int NumHiddenLayers,
                  int NumNeuronsPerLayer) : m_NumInputs(NumInputs),
                                            m_NumOutputs(NumOutputs),
                                            m_NumHiddenLayers(NumHiddenLayers),
                                            m_NumNeuronsPerLayer(NumNeuronsPerLayer)

{
     CreateNet();
}


//---------------------------create net-----------------------------------------
//
//------------------------------------------------------------------------------
void Concept::CreateNet(){
     m_vecLayers.push_back(NeuronLayer(m_NumNeuronsPerLayer, m_NumInputs));
     if (m_NumHiddenLayers > 1){
        for (int i=0; i<m_NumHiddenLayers-1; i++)
            m_vecLayers.push_back(NeuronLayer(m_NumNeuronsPerLayer, m_NumNeuronsPerLayer));
     }

     m_vecLayers.push_back(NeuronLayer(m_NumOutputs, m_NumNeuronsPerLayer));

     return;

}


//---------------------------get weights----------------------------------------
//
//  returns a vector containing the weights
//
//------------------------------------------------------------------------------

vector<float> Concept::GetWeights(){
     vector<float> weights;
     for (int i=0; i<m_NumHiddenLayers + 1; i++){
         for (int j=0; j<m_vecLayers[j].m_NumNeurons; j++){
             for (int k=0; k<m_vecLayers[i].m_vecNeurons[j].m_NumInputs; k++){
                 weights.push_back(m_vecLayers[i].m_vecNeurons[j].m_vecWeight[k]);
             }
         }
     }
     return weights;
}

//---------------------------put weights----------------------------------------
//
//  given a vector of floats this function replaces the weights in the NN values
//
//------------------------------------------------------------------------------

void Concept::PutWeights(vector<float> weights){
     int cWeight = 0;
         for (int i=0; i<m_NumHiddenLayers + 1; i++){
             for (int j=0; j<m_vecLayers[i].m_NumNeurons; j++){
                 for (int k=0; k<m_vecLayers[i].m_vecNeurons[j].m_NumInputs; k++){
                     m_vecLayers[i].m_vecNeurons[j].m_vecWeight[k] = weights[cWeight++];
                 }
             }
         }
     return;
}

//------------------------get number fo weights---------------------------------
//
//  returns the total number of weights needed for the net
//
//------------------------------------------------------------------------------

int Concept::GetNumberOfWeights(){
    int weights = 0;
    for (int i=0; i<m_NumHiddenLayers +1; i++){
        for (int j=0; j<m_vecLayers[i].m_NumNeurons; j++){
            for (int k=0; k<m_vecLayers[i].m_vecNeurons[j].m_NumInputs; k++)
                weights++;
        }
    }
    return weights;
}

//-----------------------------update-------------------------------------------
//
//  Given an input vector this function calculates the output vector
//
//------------------------------------------------------------------------------

vector<float> Concept::Update(vector<float> inputs){
   vector<float> outputs;
   int cWeight = 0;

   if (inputs.size() != m_NumInputs)
      return outputs;

   for (int i=0; i<m_NumHiddenLayers +1; i++){
       if ( i > 0 )
          inputs = outputs;

       outputs.clear();

       cWeight = 0;

       for (int j=0; j<m_vecLayers[i].m_NumNeurons; j++){
           float netinput = 0.0f;
           int NumInputs = m_vecLayers[i].m_vecNeurons[j].m_NumInputs;

           for (int k=0; k<NumInputs - 1; k++){
               netinput += m_vecLayers[i].m_vecNeurons[j].m_vecWeight[k] * inputs[cWeight++];
           }

           netinput += m_vecLayers[i].m_vecNeurons[j].m_vecWeight[NumInputs-1] * BIAS;

           outputs.push_back(Sigmoid (netinput, ACTIVATION_RESPONSE));

           cWeight = 0;

       }
   }
   return outputs;
}

//-----------------------------sigmoid------------------------------------------
//
//------------------------------------------------------------------------------

float Concept::Sigmoid(float netinput, float response){
      return (1 / ( 1 + exp(-netinput / response)));
}
