#ifndef CONCEPT_H
#define CONCEPT_H

//-------------------------------------Concept.h--------------------------------
//
//    ChadNet by Chad Rempp
//    March 1 2002
//    Version 0.0.01
//
//	  Also Stolen from M Buckland
//
//    Concept Class
//    Represents a concept through an NN
//
//------------------------------------------------------------------------------

#include <vector>
#include "CNeuralNet.h"

using namespace std;

class Concept{

private:
       int m_NumInputs;
       int m_NumOutputs;
       int m_NumHiddenLayers;
       int m_NumNeuronsPerLayer;
       vector<NeuronLayer> m_vecLayers;

public:
       Concept();
       Concept( int NumInputs,
                int NumOutputs,
                int NumHiddenLayers,
                int NumNeuronsPerLayer);
       void CreateNet();
       vector<float> GetWeights();
       int GetNumberOfWeights();
       void PutWeights(vector<float> weights);
       vector<float> Update(vector<float> inputs);
       inline float Sigmoid(float activation, float response);

};

#endif
